#!/usr/bin/rexx
/*****************************************************************************
*  File Name: sconfig.cmd                                                    *
*                                                                            *
*  Description:  This program creates dynamic WEB pages and updates the      *
*                 demo's configuration, by re-writing Welcome.htm,           *
*                 schome.map and scconf.hti                                  *
*                                                                            *
*                    ------------------------------------                    *
*                                                                            *
*   Licensed Materials - Property of IBM                                     *
*                                                                            *
*   (C) COPYRIGHT International Business Machines Corp. 1996                 *
*    All Rights Reserved.                                                    *
*                                                                            *
*   US Government Users Restricted Rights - Use, duplication or              *
*   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.        *
*                                                                            *
*                    ------------------------------------                    *
*                                                                            *
*               NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                  *
*                                                                            *
*  INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE      *
*  EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS" WITHOUT    *
*  WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT     *
*  LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A    *
*  PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE    *
*  OF THE SOURCE CODE EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, *
*  IS WITH YOU.  SHOULD ANY PART OF THE SOURCE CODE EXAMPLES PROVE           *
*  DEFECTIVE, YOU (AND NOT IBM) ASSUME THE ENTIRE COST IF ALL NECESSARY      *
*  SERVICING, REPAIR OR CORRECTION.                                          *
*                                                                            *
******************************************************************************/
env='environment'

Parse arg test test1
ServerName=Value("SERVER_NAME",,env)

Say 'Content-type: text/html'
Say

/** header block of the web page **/
Say '<html><head>'
Say '<title>Performance Automobiles, Ltd - Configuration</title>'
Say '</head>'
Say '<BODY TEXT="#FFFFFF" LINK="#3399FF" VLINK="#FF0033" BGCOLOR="#000000" ALINK="#FFFF00">'
Say '<A HREF="/scdemo/Welcome.htm"><img src="/scdemo/icons/head.gif" ALIGN="MIDDLE" alt=""></A>'
Say '<hr>'
Say '<img src="/scdemo/icons/confgban.gif" alt="">'

lineLength = Value("CONTENT_LENGTH",,env)

/** initialize default input data **/
dbname='VEHICLES'
userid='USERID'
pwd   =''
webreg='SCREGTRY'
rmtaddr=Value("REMOTE_ADDR",,env)
dir   ='http://'ServerName'/cgi-bin/db2www/'
path  ='/scdemo/'
drive =''
incdir=''
htmdir=''

If lineLength<=0 | Value("REQUEST_METHOD",,env)="GET" Then
 Do
  Call CreateWebPage
 End
Else
 Do
  stdInput=Linein()

  stdInput=Translate(RemoveESCseq(stdInput),' ','+')
  Do i=1 by 1 Until stdInput=''
    Parse  Var stdInput Name.i '=' Value.i '&' stdInput
    name=Translate(name.i)
    Select
     When name='DBNAME'  Then dbname =Strip(Value.i)
     When name='USERID'  Then userid =Strip(Value.i)
     When name='DRIVE'   Then drive  =Strip(Value.i)
     When name='PWD'     Then pwd    =Strip(Value.i)
     When name='WEBREG'  Then webreg =Strip(Value.i)
     When name='RMTADDR' Then rmtaddr=Strip(Value.i)
     When name='DIR'     Then dir    =Strip(Value.i)
     When name='PATH'    Then path   =Strip(Value.i)
     When name='INCDIR'  Then incdir =Strip(Value.i)
     When name='HTMDIR'  Then htmdir =Strip(Value.i)
     Otherwise NOP
    End
  End

  If dbname='' | userid='' | pwd='' | webreg='' |,
     rmtaddr='' | dir='' | path='' | incdir='' | htmdir='' Then,
        Call CreateWebPage
  Else  Call SetConfiguration
 End

/** footer of the web page **/
Say '<hr><table  border =0 width=450>'
Say '<tr>'
Say '<td>'
Say '<A HREF="/scdemo/Welcome.htm"><img src="/scdemo/icons/homeIcon.gif"',
     'ALIGN=middle ALT="Home page"> HOME PAGE</A>'
Say '</td>'
Say '<td align=center>'
Say '<A HREF="/scdemo/scrdme.htm"><img src="/scdemo/icons/glasses.gif"',
     'ALIGN=middle alt=""> READ ME FIRST'
Say '</A>'
Say '</td>'
Say '</table>'

Say '<hr><B>&#91;'

Say '<A HREF="/scdemo/Welcome.htm">Home page</A> |'
Say '<A HREF="/scdemo/scrdme.htm">Read me first</A> |'
Say '<A HREF="http://www.ibm.com/common/copyright.html">(C)</A> |'
Say '<A HREF="http://www.ibm.com/common/trademarks.html">(TM)</A>'
Say '&#93;</B>'
Say '</body></html>'

Exit


/*****************************************************************************
*  Subroutine: SetConfiguration                                              *
*                                                                            *
*  Description:  Forerunner to setting up the various configuration files    *
*                                                                            *
******************************************************************************/
SetConfiguration:
 h=0; s=0
 htmdir=Strip(Strip(Strip(htmdir,'t','0a'x),'t','0d'x),'t','/')||'/'
 incdir=Strip(Strip(Strip(incdir,'t','0a'x),'t','0d'x),'t','/')||'/'

 If Stream(htmdir||'schome.map','c','query exists')<>"" Then h=1  
 If Stream(incdir||'scconf.hti','c','query exists')<>"" Then s=1

 If h=1 & s=1 Then
  Do
   /** update/write the respective files **/
   Say '<h3>Here is your configuration Information.</h3>'
   Say '<table width=500>'
   Say '<tr>'
   Say '<td><b>Database Name:</b></td>'
   Say '<td>'dbname'</td>'
   Say '<tr>'
   Say '<td><b>Userid:</b></td>'
   Say '<td>'userid'</td>'
   Say '<tr>'
   Say '<td><b>Password:</b></td>'
   Say '<td>'pwd'</td>'
   Say '<tr>'
   Say '<td><b>Registry Name:</b></td>'
   Say '<td>'webreg'</td>'
   Say '<tr>'
   Say '<td><b>Authorized Remote Addresses:</b></td>'
   Say '<td>'rmtaddr'</td>'
   Say '<tr>'
   Say '<td><b>URL of Net.Data:</b></td>'
   Say '<td>'dir'</td>'
   Say '</table>'
   subdir='/'||Strip(Substr(dir,Pos('/',dir,9)),,'/')||'/'
   If Stream(incdir||'scconf.hti','c','open write replace')="READY:" &,
      Stream(htmdir||'schome.map','c','open write replace')="READY:" &,
      Stream(htmdir||'Welcome.htm','c','open write replace')="READY:" Then
    Do
     Call CreateConfigFile(incdir||'scconf.hti')
     Call CreateHomeMap htmdir||'schome.map'
     Call CreateWelcomePage htmdir||'Welcome.htm'
     Call Stream incdir||'scconf.hti','c','close'
     Call Stream htmdir||'schome.map','c','close'
     Call Stream htmdir||'Welcome.htm','c','close'
     Say '<p>The following three files were generated using the above information:'
     Say '<ul>'
     Say '<li>'htmdir||'Welcome.htm'
     Say '<li>'htmdir||'schome.map'
     Say '<li>'incdir||'scconf.hti'
     Say '</ul>'
     Say '<i>If the information is correct, you are now ready to initialize your database.</i>'
     Say '<p>'
     Say '<i>Note: When you get back to the Home Page, you should refresh the page because'
     Say 'a new HTML file has been generated for it.</i>'
     Say '<p>'
    End
   Else
    Do
   /** Error ... **/
     Say '<h2>Cannot continue with configuration</h2>'
     Say '<p>Server does not have write authority to update the configuration files.'
     Say '<p>Check if server is configured properly and has write access.'
     Say '<p>'
     say '<p>'incdir||'scconf.hti'
     say '<p>'htmdir||'schome.map'
     say '<p>'htmdir||'Welcome.htm'
     say '<p>'Stream(incdir||'scconf.hti','d')
     say Stream(htmdir||'schome.map','d')
     say Stream(htmdir||'Welcome.htm','d')
    End
  End
 Else 
  Do
   /** Error ... **/
   Say '<h2>Cannot continue with configuration</h2>'
   Say '<p>Expected configuration files were not found.'
   Say '<p>Check if the paths are correct.'
  End
Return

/*****************************************************************************
*  Subroutine: CreateConfigFile                                              *
*                                                                            *
*  Description:  Creates the file scconf.hti                                 *
*                                                                            *
******************************************************************************/
CreateConfigFile:
 Parse Arg configFile
 n=0
 n=n+1; line.n='%{*****************************************************************************/'
 n=n+1; line.n='/*                                                                            */'
 n=n+1; line.n='/*   File Name                                                                */'
 n=n+1; line.n='/*      scconf.hti                                                            */'
 n=n+1; line.n='/*                                                                            */'
 n=n+1; line.n='/*   Description                                                              */'
 n=n+1; line.n='/*      This Macro Processor include file contains defines which are          */'
 n=n+1; line.n='/*      configuration related used by this demo''s macros                      */'
 n=n+1; line.n='/*                                                                            */'
 n=n+1; line.n='/*   Created:  'Date("S") Left(Time("S"),5) Copies(' ',29)'                   */'
 n=n+1; line.n='/*                                                                            */'
 n=n+1; line.n='/*                    ------------------------------------                    */'
 n=n+1; line.n='/*                                                                            */'
 n=n+1; line.n='/*   Licensed Materials - Property of IBM                                     */'
 n=n+1; line.n='/*                                                                            */'
 n=n+1; line.n='/*   (C) COPYRIGHT International Business Machines Corp. 1996                 */'
 n=n+1; line.n='/*    All Rights Reserved.                                                    */'
 n=n+1; line.n='/*                                                                            */'
 n=n+1; line.n='/*   US Government Users Restricted Rights - Use, duplication or              */'
 n=n+1; line.n='/*   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.        */'
 n=n+1; line.n='/*                                                                            */'
 n=n+1; line.n='/*                    ------------------------------------                    */'
 n=n+1; line.n='/*                                                                            */'
 n=n+1; line.n='/*               NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                  */'
 n=n+1; line.n='/*                                                                            */'
 n=n+1; line.n='/*  INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE      */'
 n=n+1; line.n='/*  EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS" WITHOUT    */'
 n=n+1; line.n='/*  WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT     */'
 n=n+1; line.n='/*  LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A    */'
 n=n+1; line.n='/*  PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE    */'
 n=n+1; line.n='/*  OF THE SOURCE CODE EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, */'
 n=n+1; line.n='/*  IS WITH YOU.  SHOULD ANY PART OF THE SOURCE CODE EXAMPLES PROVE           */'
 n=n+1; line.n='/*  DEFECTIVE, YOU (AND NOT IBM) ASSUME THE ENTIRE COST IF ALL NECESSARY      */'
 n=n+1; line.n='/*  SERVICING, REPAIR OR CORRECTION.                                          */'
 n=n+1; line.n='/*                                                                            */'
 n=n+1; line.n='/*****************************************************************************%}'
 n=n+1; line.n=''
 n=n+1; line.n='%{*****************************************************************************/'
 n=n+1; line.n='/*   GLOBAL DEFINEs - Database related                                        */'
 n=n+1; line.n='/*****************************************************************************%}'
 n=n+1; line.n='%DEFINE {'
 n=n+1; line.n=' DATABASE = "'dbname'"'
 n=n+1; line.n=' LOGIN    = "'userid'"'
 n=n+1; line.n=' PASSWORD = "'pwd'"'
 n=n+1; line.n=' REGISTRY = "'webreg'"'
 n=n+1; line.n=' RMTADDR  = "'Translate(rmtAddr," ",",")'"'
 n=n+1; line.n=' TABLEQLFR= "'dbname'"'
 n=n+1; line.n='%}'
 n=n+1; line.n=''
 n=n+1; line.n='%{*****************************************************************************/'
 n=n+1; line.n='/*   GLOBAL DEFINEs - DEMO''s directory configuration                          */'
 n=n+1; line.n='/*****************************************************************************%}'
 n=n+1; line.n='%DEFINE {'
 n=n+1; line.n=' MACRO = "'subdir'"'
 n=n+1; line.n=' prod  = "'path'"'
 n=n+1; line.n='%}'
 line.0=n
 Do i=1 to line.0
  Call Lineout configFile, line.i
 End
Return 

/*****************************************************************************
*  Subroutine: CreateHomePage                                                *
*                                                                            *
*  Description:  Creates the file schome.map                                 *
*                                                                            *
******************************************************************************/
CreateHomeMap:
 Parse Arg homeMap
 n=0
 n=n+1; line.n='default 'subdir'scshowrm.mac/report'
 n=n+1; line.n='rect (3,405) (157,331) 'subdir'scuser.mac/logon'
 n=n+1; line.n='rect (92,328) (354,252) 'subdir'scshowrm.mac/report'
 n=n+1; line.n='rect (119,420) (423,488) 'path'scrdme.htm'
 n=n+1; line.n='rect (316,346) (494,403) 'subdir'scqmain.mac/input'
 line.0=n
 Do i=1 to line.0
  Call Lineout homeMap, line.i
 End
Return

/*****************************************************************************
*  Subroutine: CreateWelcomePage                                             *
*                                                                            *
*  Description:  Creates the file welcome.htm                                *
*                                                                            *
******************************************************************************/
CreateWelcomePage:
 Parse Arg welcomePage
 n=0
 n=n+1; line.n='<!DOCTYPE HTML SYSTEM "html.dtd">'
 n=n+1; line.n='<html>'
 n=n+1; line.n='<HEAD>'
 n=n+1; line.n='<title>Performance Automobiles, Ltd Home Page</title>'
 n=n+1; line.n='</HEAD>'
 n=n+1; line.n='<BODY TEXT="#FFFFFF" LINK="#3399FF" VLINK="#FF0033" BGCOLOR="#000000">'
 n=n+1; line.n='<center>'
 n=n+1; line.n='<img src="'path'icons/head.gif" alt="Sports Car Demo" >'
 n=n+1; line.n='</center>'
 n=n+1; line.n='<center>'
 n=n+1; line.n='<table border=0 width=480>'
 n=n+1; line.n='<tr>'
 n=n+1; line.n='<td><a href="/cgi-bin/htimage'path'schome.map">'
 n=n+1; line.n='<img src="'path'icons/homemap.gif" Ismap align=center alt=""></a>'
 n=n+1; line.n='<p>'
 n=n+1; line.n='<tr>'
 n=n+1; line.n='<td> You have just entered a virtual  automobile sales company.'
 n=n+1; line.n='We sell technologically advanced, aerodynamically tuned'
 n=n+1; line.n='<em>performance automobiles</em> <br>'
 n=n+1; line.n='<p>'
 n=n+1; line.n='</table>'
 n=n+1; line.n='</center>'
 n=n+1; line.n=''
 n=n+1; line.n='<img src="'path'icons/lineCar.gif" alt="">'
 n=n+1; line.n='<br>'
 n=n+1; line.n='<B>'
 n=n+1; line.n='&#91;'
 n=n+1; line.n='<a href="'subdir'scshowrm.mac/report">Show room</A> |'
 n=n+1; line.n='<a href="'subdir'scuser.mac/logon">Logon</A> |'
 n=n+1; line.n='<a href="'subdir'scqmain.mac/input">Query</A> |'
 n=n+1; line.n='<a href="scrdme.htm">Read Me First</A> '
 n=n+1; line.n='&#93;'
 n=n+1; line.n='<br>'
 n=n+1; line.n='&#91;'
 n=n+1; line.n='<a href="http://www.software.ibm.com/data/net.data/">Net.Data</a> |'
 n=n+1; line.n='<a href="http://www.software.ibm.com/data/net.data/demos/demopage.html">Net.Data Product Demonstrations</a> |'
 n=n+1; line.n='<a href="http://www.software.ibm.com/">Software home</a> |'
 n=n+1; line.n='<a href="http://www.software.ibm.com/shortcut.html">Short cuts</a>'
 n=n+1; line.n='&#93;'
 n=n+1; line.n='<br>'
 n=n+1; line.n='&#91;'
 n=n+1; line.n='<a href="http://www.ibm.com/">IBM Home Page</a> |'
 n=n+1; line.n='<a href="http://www.ibm.com/Orders/">Order</a> |'
 n=n+1; line.n='<a href="http://www.ibm.com/Search/">Search</a> |'
 n=n+1; line.n='<a href="http://www.ibm.com/Assist/">Contact IBM</a> |'
 n=n+1; line.n='<a href="http://www.ibm.com/Finding/">Help</a> |'
 n=n+1; line.n='<a href="http://www.ibm.com/copyright.html">(C)</a> |'
 n=n+1; line.n='<a href="http://www.ibm.com/trademarks.html">(TM)</a>'
 n=n+1; line.n='&#93;'
 n=n+1; line.n='</B>'
 n=n+1; line.n='</BODY>'
 n=n+1; line.n='</HTML>'
 line.0=n
 Do i=1 to line.0
  Call Lineout welcomePage, line.i
 End
Return

/*****************************************************************************
*  Subroutine: CreateWebPage                                                 *
*                                                                            *
*  Description:  Creates the configuration form WEB page                     *
*                                                                            *
******************************************************************************/
CreateWebPage:
 Say '<table width=600>',
     '<tr><td colspan=2>'
 Say '<p>Now, it is time to configure the demo.',
     '<p>Database Name, Userid, and Password are associated',
         'with parameters required when setting up a database.  You may want to',
         'consult your DB2 references on creating databases for additional help.',
     '<p>Registry Name is used for WEB Registry and any name will suffice.'

 Say '<p>Remote Addresses is one or more TCP/IP addresses, delimited by a blank',
         'or comma.  These addresses are used to authenticate who is allowed to',
         '<i>Initialize the demo</i>.',
     '<p>Path to Demo''s HTML pages and Net.Data includes is required to update',
     ' the appropriate files.',
     '<p>URL of Net.Data provides the information of how to invoke the Net.Data CGI-BIN.',
     '<p>Values are required for all fields.  Defaults are provided except for',
     ' Password and Path information fields.'

 Say '<FORM METHOD="POST" ACTION="/scdemo/cgi-bin/scconfig.cmd">'

 Say '<tr>',
     '<td>Database Name:</td>',
     '<td><INPUT TYPE="text"     NAME="dbname"  VALUE="'dbname'" SIZE=8',
      'MAXLENGTH=8></td>'

 Say '</SELECT></td>'

 Say '<tr><td>',
     '<tr>',
     '<td>Userid:</td>',
     '<td><INPUT TYPE="text"     NAME="userid"  VALUE="'userid'"  SIZE=8',
       'MAXLENGTH=8></td>'

 Say '<tr><td>',
     '<tr>',
     '<td>Password:</td>',
     '<td><INPUT TYPE="password" NAME="pwd"     VALUE="'pwd'"     SIZE=6',
       'MAXLENGTH=8></td>'

 Say '<tr><td>',
     '<tr>',
     '<td>Registry Name:</td>',
     '<td><INPUT TYPE="text"     NAME="webreg"  VALUE="'webreg'"  SIZE=8',
       'MAXLENGTH=8></td>'

 Say '<tr><td>',
     '<tr>',
     '<td>Remote Addresses:</td>',
     '<td><INPUT TYPE="text"     NAME="rmtaddr" VALUE="'rmtaddr'" SIZE=30',
       'MAXLENGTH=100></td>'

 Say '<tr><td>',
     '<tr>',
     '<td>Path to Demo''s HTML pages:</td>',
     '<td><INPUT TYPE="text"     NAME="htmdir"  VALUE="'htmdir'"  SIZE=30',
       'MAXLENGTH=70></td>'

 Say '<tr><td>',
     '<tr>',
     '<td>Path to Demo''s Net.Data includes:</td>',
     '<td><INPUT TYPE="text"     NAME="incdir"  VALUE="'incdir'"  SIZE=30',
       'MAXLENGTH=70></td>'

 Say '<tr><td>',
     '<tr>',
     '<td>URL of Net.Data:</td>',
     '<td><INPUT TYPE="text"     NAME="dir"     VALUE="'dir'"     SIZE=30',
       'MAXLENGTH=70></td>'

 Say '<br>'
 Say '<tr><td><tr><td colspan=2><INPUT TYPE="submit" VALUE="CONFIGURE">'
 Say '</FORM>'
 Say '</table>'
Return

/*****************************************************************************
*  Subroutine: RemoveESCseq                                                  *
*                                                                            *
*  Description:  Removes any escape sequences as obtained from STDIN         *
*                                                                            *
******************************************************************************/
RemoveESCseq:
 Procedure
 Parse Arg in
 Do While Pos('%',in)<>0
  Parse Var in pre '%' +1 char +2 in
  If Verify(Translate(char),'0123456789ABCDEF')=0 Then,
       in=pre||X2C(char)||in
  Else in=pre||X2C('27')||char||in
 End
Return in
