#!/usr/bin/rexx
/*****************************************************************************
*  File Name: scinit.cmd                                                     *
*                                                                            *
*  Description:  This program creates the WEB page which provides a link     *
*                 to initialize the Database and Registry for the Demo       *
*                                                                            *
*                    ------------------------------------                    *
*                                                                            *
*   Licensed Materials - Property of IBM                                     *
*                                                                            *
*   (C) COPYRIGHT International Business Machines Corp. 1996                 *
*    All Rights Reserved.                                                    *
*                                                                            *
*   US Government Users Restricted Rights - Use, duplication or              *
*   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.        *
*                                                                            *
*                    ------------------------------------                    *
*                                                                            *
*               NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                  *
*                                                                            *
*  INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE      *
*  EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS" WITHOUT    *
*  WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT     *
*  LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A    *
*  PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE    *
*  OF THE SOURCE CODE EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, *
*  IS WITH YOU.  SHOULD ANY PART OF THE SOURCE CODE EXAMPLES PROVE           *
*  DEFECTIVE, YOU (AND NOT IBM) ASSUME THE ENTIRE COST IF ALL NECESSARY      *
*  SERVICING, REPAIR OR CORRECTION.                                          *
*                                                                            *
******************************************************************************/
env = 'environment'

Say 'Content-type: text/html'
Say

Say '<html><head>'
Say '<title>Performance Automobiles, Ltd - Initialization</title>'
Say '</head>'
Say '<BODY TEXT="#FFFFFF" LINK="#3399FF" VLINK="#FF0033" BGCOLOR="#000000" ALINK="#FFFF00">'
Say '<A HREF="/scdemo/Welcome.htm"><img src="/scdemo/icons/head.gif" ALIGN="MIDDLE" ALT=""></A>'
Say '<hr>'
Say '<img src="/scdemo/icons/initban.gif" ALT="">'

/** initialize default input data **/
incdir=''

lineLength = Value("CONTENT_LENGTH",,env)

If lineLength<=0 | Value("REQUEST_METHOD",,env)="GET" Then
 Do
  Call CreateWebPage
 End
Else
 Do
  stdInput=Linein()

  stdInput=Translate(RemoveESCseq(stdInput),' ','+')
  Do i=1 by 1 Until stdInput=''
    Parse  Var stdInput Name.i '=' Value.i '&' stdInput
    name=Translate(name.i)
    Select
     When name='INCDIR'  Then incdir =Strip(Value.i)
     Otherwise NOP
    End
  End

  If incdir='' Then  Call CreateWebPage
               Else  Call InitializeWebPage
 End

Say '<hr><table  border =0 width=450>'
Say '<tr>'
Say '<td>'
Say '<A HREF="/scdemo/Welcome.htm"><img src="/scdemo/icons/homeIcon.gif"',
     'ALIGN="MIDDLE" ALT="Home page "> HOME PAGE</A>'
Say '</td>'
Say '<td align=center>'
Say '<A HREF="/scdemo/scrdme.htm"><img src="/scdemo/icons/glasses.gif"',
     'ALIGN="MIDDLE" ALT=""> READ ME FIRST'
Say '</A>'
Say '</td>'
Say '</table>'

Say '<hr><B>&#91;'

Say '<A HREF="/scdemo/Welcome.htm">Home page</A> |'
Say '<A HREF="/scdemo/scrdme.htm">Read me first</A> |'
Say '<A HREF="http://www.ibm.com/common/copyright.html">(C)</A> |'
Say '<A HREF="http://www.ibm.com/common/trademarks.html">(TM)</A>'
Say '&#93;</B>'
Say '</body></html>'

Exit


/*****************************************************************************
*  Subroutine: CreateWebPage                                                 *
*                                                                            *
*  Description:  Creates the main body of the WEB page                       *
*                                                                            *
******************************************************************************/
CreateWebPage:
 Say '<p>',
     '<table width=600>',
     '<tr><td colspan=2>'
 Say '<p><font size="+1">Now, it is time to initialize the demo.</font>'

 Say '<FORM METHOD="POST" ACTION="/scdemo/cgi-bin/scinit.cmd">'

 Say '<tr><td>',
     '<tr>',
     '<td>Please enter the full path to the demo''s Net.Data includes:</td>',
     '<td><INPUT TYPE="text"     NAME="incdir"  VALUE="'incdir'"  SIZE=30',
       'MAXLENGTH=70></td>'

 Say '<br>'
 Say '<tr><td><tr><td colspan=2><INPUT TYPE="submit" VALUE="INITIALIZE">'
 Say '</FORM>'
 Say '</table>'
Return


/*****************************************************************************
*  Subroutine: InitializeWebPage                                             *
*                                                                            *
*  Description:  Creates the WEB page with the initialize link               *
*                                                                            *
******************************************************************************/
InitializeWebPage:

 s=0
 incdir=Strip(Strip(Strip(incdir,'t','0a'x),'t','0d'x),'t','/')||'/'
 fileName = incdir||'scconf.hti'
/*
say '<p>.here...'length("/afs/rchland/usr6/lourenco/netdata/include/scdemo")'..'length(incddir) '..'fileName
 */
 If Stream(fileName,'c','query exists')<>"" Then
  Do
   If Stream(fileName,'c','open read')="READY:" Then
    Do
     leaveFlag=0
     Do While Lines(fileName)
      Parse Value Linein(fileName) With def key date time rest
      If Translate(key)='CREATED:' Then
       Do
        s=s+1
        sfile.s=file.j
        date.s=date
        time.s=time
        mdir.s=''
        leaveFlag=1
       End
      Else If Pos('MACRO',def' 'key' 'date' 'time' 'rest)>0 &,
             leaveFlag Then
       Do
        line_in=def' 'key' 'date' 'time' 'rest
        Parse Var line_in '"' mdir.s '"'
        Leave
       End
     End
     rc=Stream(fileName,'c','close')
    End
  End

 If s<1 Then
  Do
   /** Error ... **/
   Say '<h2>Cannot continue with demo initialization</h2>'
   Say '<p>Expected configuration files were not found.'
   Say '<p>Check if your installation process is correct, and ',
       'that your demo include paths are correct.'
  End
 Else
  Do
   date=0
   time=0
   Do i=1 to s
    Select
     When date.i>date & mdir.i<>'' Then
      Do
       date=date.i
       time=time.i
       sfile=sfile.i
       mdir=mdir.i
      End
     When date.i=date & time.i>time & mdir.i<>'' Then
      Do
       date=date.i
       time=time.i
       sfile=sfile.i
       mdir=mdir.i
      End
     Otherwise NOP
    End
    Say '<br>'
   End
   Say '<p>'
   Say 'During initialization, the demo''s <b>database</b> is initialized.  The database ',
       'must be created prior to continuing the next process.  If you do not have created ',
       'the database, this is as good time as any to do it.'
   Say '<p>The demo''s <b>WEB registry</b>  will be created and initialized.',
       '<p><font size="+1"><b>Previously entered data will be lost.</b></font>'
   Say '<p>'
   Say 'Now the only thing left to do is to',
       '<A href="'mdir'scinit.mac/init">INITIALIZE</A> the Demo.'
   Say '<p>'
  End
Return


/*****************************************************************************
*  Subroutine: RemoveESCseq                                                  *
*                                                                            *
*  Description:  Removes any escape sequences as obtained from STDIN         *
*                                                                            *
******************************************************************************/
RemoveESCseq:
 Procedure
 Parse Arg in
 Do While Pos('%',in)<>0
  Parse Var in pre '%' +1 char +2 in
  If Verify(Translate(char),'0123456789ABCDEF')=0 Then,
       in=pre||X2C(char)||in
  Else in=pre||X2C('27')||char||in
 End
Return in
