static char sqla_program_id[40] = 
{65,111,66,65,71,65,68,65,76,79,85,82,69,78,67,79,83,67,76,77,
49,53,51,32,48,65,82,80,77,88,75,77,48,49,49,49,49,32,32,32};


#include "sqladef.h"

static struct sqla_runtime_info sqla_rtinfo = 
{{'S','Q','L','A','R','T','I','N'}, sizeof(wchar_t), 0, {' ',' ',' ',' '}};


#line 1 "sclm153.sqx"
/**********************************************************************
*  FileName:  SCLM153.SQX                         
*
*  This program will set up the routing information in the database.
*
*   Licensed Materials - Property of IBM                               
*                                                                      
*   (C) COPYRIGHT International Business Machines Corp. 1996           
*    All Rights Reserved.                                              
*                                                                      
*   US Government Users Restricted Rights - Use, duplication or        
*   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  
*                                                                      
*                    ------------------------------------              
*                                                                      
*               NOTICE TO USERS OF THE SOURCE CODE EXAMPLES            
*                                                                      
*  INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE 
*  CODE EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, 
*  "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
*  INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF 
*  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE 
*  RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,
*  BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD 
*  ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT 
*  IBM) ASSUME THE ENTIRE COST IF ALL NECESSARY SERVICING, REPAIR OR 
*  CORRECTION.                                      
*                                                                      
**********************************************************************/

#include <sql.h>
#include <sqlenv.h>
#include <sqlda.h>
#include <sqlca.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>



/*
EXEC SQL INCLUDE SQLCA;
*/

/* SQL Communication Area - SQLCA - structures and constants */
#include "sqlca.h"
struct sqlca sqlca;


#line 41 "sclm153.sqx"


static char* SQLFunctionName;                /* Function name        */
static long SQL_error = 0;                   /* Save first SQL error */

const int MAXWORD = 30;

/*  Function declarations  */
int check_error (char eString[], struct sqlca *caPointer);
#define  CHECKERR(CE_STR)   if ( check_error(CE_STR, &sqlca) != 0) \
                               return 1;

float getTime(char* table, char* from, char* to);

static long autoBind(char *, char *, char *);

/*********************************************************************/

int main(int argc, char* argv[])
{
   /* declarations associated with SQL */
   
/*
EXEC SQL BEGIN DECLARE SECTION;
*/

#line 62 "sclm153.sqx"

      char   st[512];			
      char   word0[30];
      char   word1[30];
      char   word2[30];
      char   word3[30];
      char   from[30];
      char   to[30];
      double theTime;
      long   reqNumber;
      long   sequenceNo=0;

      char   db[9];
      char   uid[9];
      char   pwd[19];
      char   bindFile[512];
      char   msgFile[512];
      char   purchaseTable[30];
      char   timeTable[30];
   
/*
EXEC SQL END DECLARE SECTION;
*/

#line 81 "sclm153.sqx"



   /* declare for cursor */
   
/*
EXEC SQL DECLARE c1 CURSOR FOR statement1;
*/

#line 85 "sclm153.sqx"
  


   /* declarations associated with the rest of the program. */
   char   tempWord[MAXWORD];
   int    compareResult,
          rc = 0,
          rcInit = 0;  


   /* retrieve the environment variables for data base access */
   char  *dbname   = getenv("SCLMDB");
   char  *userid   = getenv("SCLMUID");
   char  *password = getenv("SCLMPWD");

   /* declarations associated with the program name */
   char  *pgmName = argv[0];
   char  *locExt;
   size_t  pgmNameLen;

   /* Check to make sure that exactly three arguments have been *
    *  passed.                                                  */
   if (argc != 3) {
      printf("<br>USAGE: requires exactly three arguments.<br>");
      return 1;
   } /* endif */


   /* Initialize local variables */
   db[0]='\0';
   uid[0]='\0';
   pwd[0]='\0';
   bindFile[0]='\0';
   msgFile[0]='\0';
   purchaseTable[0]='\0';
   timeTable[0]='\0';

   /* Copy the input parameters.*/ 
   strcpy(db, dbname);
   strcpy(uid, userid);
   strcpy(pwd, password);

   /* Get program name */ 
   if ((locExt=strrchr(pgmName,'.')) != NULL) 
     pgmNameLen = locExt-pgmName; 
   else
     pgmNameLen = strlen(pgmName);

   /* Create a bindfile name based on the program name.*/ 
   strncpy(bindFile, pgmName, pgmNameLen);
   strcat(bindFile, ".bnd");

   /* Create a msgfile based on the program name.*/ 
   strncpy(msgFile, pgmName, pgmNameLen);
   strcat(msgFile, ".msg");

   /* Copy the input arguments.*/ 
   strcpy (purchaseTable, argv[1]);
   strcpy (timeTable, argv[2]);

   /* Connect to the database */
   strcpy(st,db);
   if (strlen(uid)>0) {
     sprintf(st, "%s USER %s",
                  st,
                  uid);
     if (strlen(pwd)>0) {
       sprintf(st, "%s USING %s",
                    st,
                    pwd);
     } 
   }

   
/*
EXEC SQL CONNECT TO :st;
*/

{
#line 158 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 158 "sclm153.sqx"
  sqlaaloc(2,1,1,0L);
    {
      struct sqla_setd_list sql_setdlist[1];
#line 158 "sclm153.sqx"
      sql_setdlist[0].sqltype = 460; sql_setdlist[0].sqllen = 512;
#line 158 "sclm153.sqx"
      sql_setdlist[0].sqldata = (void*)st;
#line 158 "sclm153.sqx"
      sql_setdlist[0].sqlind = 0L;
#line 158 "sclm153.sqx"
      sqlasetd(2,0,1,sql_setdlist,0L);
    }
#line 158 "sclm153.sqx"
  sqlacall((unsigned short)29,4,2,0,0L);
#line 158 "sclm153.sqx"
  sqlastop(0L);
}

#line 158 "sclm153.sqx"

   CHECKERR ("CONNECT");
   if (SQL_error < 0) {
      printf("%s:  SQL_error (RC = %d<br>", pgmName, SQL_error);
      return 0;
   }

   /* Bind to database */
   rcInit = autoBind(bindFile, msgFile, db);
   if (rcInit != 0 || SQL_error < 0) {
      printf("%s:  Autobind failure (RC = %d<br>", pgmName, rcInit);
      return rcInit;
   }


   /* Construct the LOCK TABLE SQL statement and execute it. */
   strcpy(st, "LOCK TABLE ");
   strcat(st, purchaseTable);
   strcat(st, " IN EXCLUSIVE MODE");
   
/*
EXEC SQL EXECUTE IMMEDIATE :st;
*/

{
#line 177 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 177 "sclm153.sqx"
  sqlastls(0,st,0L);
#line 177 "sclm153.sqx"
  sqlacall((unsigned short)23,2,0,0,0L);
#line 177 "sclm153.sqx"
  sqlastop(0L);
}

#line 177 "sclm153.sqx"

   CHECKERR ("LOCK PURCHASE TABLE");

   strcpy(st, 
     "SELECT ORIGIN,DEST,CUSTNAME,MODNO,REQNO,COST,ORDDATE FROM ");
   strcat(st, purchaseTable);
   strcat(st, 
     " WHERE STATUS IN ('ORDERED', 'ROUTED') ORDER BY DEST ASC, COST DESC");
   
/*
EXEC SQL PREPARE statement1 from :st;
*/

{
#line 185 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 185 "sclm153.sqx"
  sqlastls(0,st,0L);
#line 185 "sclm153.sqx"
  sqlacall((unsigned short)27,1,0,0,0L);
#line 185 "sclm153.sqx"
  sqlastop(0L);
}

#line 185 "sclm153.sqx"

   CHECKERR ("DECLARE CURSOR FOR PURCHASE TABLE");

   
/*
EXEC SQL OPEN c1;
*/

{
#line 188 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 188 "sclm153.sqx"
  sqlacall((unsigned short)26,1,0,0,0L);
#line 188 "sclm153.sqx"
  sqlastop(0L);
}

#line 188 "sclm153.sqx"

   CHECKERR ("OPEN CURSOR FOR PURCHASE TABLE");


   /* Fetch PURCHASE rows one at a time */

   while(1) {

      
/*
EXEC SQL FETCH c1 INTO :word0, :word1, :word2, :word3, :reqNumber ;
*/

{
#line 196 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 196 "sclm153.sqx"
  sqlaaloc(3,5,2,0L);
    {
      struct sqla_setd_list sql_setdlist[5];
#line 196 "sclm153.sqx"
      sql_setdlist[0].sqltype = 460; sql_setdlist[0].sqllen = 30;
#line 196 "sclm153.sqx"
      sql_setdlist[0].sqldata = (void*)word0;
#line 196 "sclm153.sqx"
      sql_setdlist[0].sqlind = 0L;
#line 196 "sclm153.sqx"
      sql_setdlist[1].sqltype = 460; sql_setdlist[1].sqllen = 30;
#line 196 "sclm153.sqx"
      sql_setdlist[1].sqldata = (void*)word1;
#line 196 "sclm153.sqx"
      sql_setdlist[1].sqlind = 0L;
#line 196 "sclm153.sqx"
      sql_setdlist[2].sqltype = 460; sql_setdlist[2].sqllen = 30;
#line 196 "sclm153.sqx"
      sql_setdlist[2].sqldata = (void*)word2;
#line 196 "sclm153.sqx"
      sql_setdlist[2].sqlind = 0L;
#line 196 "sclm153.sqx"
      sql_setdlist[3].sqltype = 460; sql_setdlist[3].sqllen = 30;
#line 196 "sclm153.sqx"
      sql_setdlist[3].sqldata = (void*)word3;
#line 196 "sclm153.sqx"
      sql_setdlist[3].sqlind = 0L;
#line 196 "sclm153.sqx"
      sql_setdlist[4].sqltype = 496; sql_setdlist[4].sqllen = 4;
#line 196 "sclm153.sqx"
      sql_setdlist[4].sqldata = (void*)&reqNumber;
#line 196 "sclm153.sqx"
      sql_setdlist[4].sqlind = 0L;
#line 196 "sclm153.sqx"
      sqlasetd(3,0,5,sql_setdlist,0L);
    }
#line 196 "sclm153.sqx"
  sqlacall((unsigned short)25,1,0,3,0L);
#line 196 "sclm153.sqx"
  sqlastop(0L);
}

#line 196 "sclm153.sqx"

      if (SQLCODE != 0) break;  // break if no more records

      compareResult = strcmp(   //
                      word0,    // the from location
                      word1 );  // the to   location
      if (compareResult == 0) {
         printf("An invalid order: from and to are same place");
         goto exit;
      }
      if (compareResult < 0) // "from" is alphabetically less than "to"
         theTime = getTime(timeTable, word0, word1) ;
      else                   // "to" is alphabetically less than "from"
         theTime = getTime(timeTable, word1, word0) ;

      /* create a a sequence number */
      sequenceNo++;

      strcpy(st, "UPDATE ");
      strcat(st, purchaseTable);
      strcat(st, " SET SEQ = ?, STATUS = 'ROUTED' WHERE REQNO = ?");
      
/*
EXEC SQL PREPARE statement3 from :st;
*/

{
#line 217 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 217 "sclm153.sqx"
  sqlastls(0,st,0L);
#line 217 "sclm153.sqx"
  sqlacall((unsigned short)27,3,0,0,0L);
#line 217 "sclm153.sqx"
  sqlastop(0L);
}

#line 217 "sclm153.sqx"

      
/*
EXEC SQL EXECUTE statement3 USING :sequenceNo, :reqNumber;
*/

{
#line 218 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 218 "sclm153.sqx"
  sqlaaloc(2,2,3,0L);
    {
      struct sqla_setd_list sql_setdlist[2];
#line 218 "sclm153.sqx"
      sql_setdlist[0].sqltype = 496; sql_setdlist[0].sqllen = 4;
#line 218 "sclm153.sqx"
      sql_setdlist[0].sqldata = (void*)&sequenceNo;
#line 218 "sclm153.sqx"
      sql_setdlist[0].sqlind = 0L;
#line 218 "sclm153.sqx"
      sql_setdlist[1].sqltype = 496; sql_setdlist[1].sqllen = 4;
#line 218 "sclm153.sqx"
      sql_setdlist[1].sqldata = (void*)&reqNumber;
#line 218 "sclm153.sqx"
      sql_setdlist[1].sqlind = 0L;
#line 218 "sclm153.sqx"
      sqlasetd(2,0,2,sql_setdlist,0L);
    }
#line 218 "sclm153.sqx"
  sqlacall((unsigned short)24,3,2,0,0L);
#line 218 "sclm153.sqx"
  sqlastop(0L);
}

#line 218 "sclm153.sqx"

      CHECKERR ("UPDATE SEQ AND STATUS IN PURCHASE TABLE");

   }  /* END WHILE */


   /* Close Cursor */
   
/*
EXEC SQL COMMIT;
*/

{
#line 225 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 225 "sclm153.sqx"
  sqlacall((unsigned short)21,0,0,0,0L);
#line 225 "sclm153.sqx"
  sqlastop(0L);
}

#line 225 "sclm153.sqx"

   CHECKERR ("COMMIT AND CLOSE CURSOR FOR PURCHASE TABLE");

   
/*
EXEC SQL CONNECT RESET;
*/

{
#line 228 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 228 "sclm153.sqx"
  sqlacall((unsigned short)29,3,0,0,0L);
#line 228 "sclm153.sqx"
  sqlastop(0L);
}

#line 228 "sclm153.sqx"

   CHECKERR ("CONNECT RESET");


   return 0;


   /* Abnormal Termination */

   exit:
   printf("Abnormal termination.  rc = %d", rc);

   
/*
EXEC SQL CONNECT RESET;
*/

{
#line 240 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 240 "sclm153.sqx"
  sqlacall((unsigned short)29,3,0,0,0L);
#line 240 "sclm153.sqx"
  sqlastop(0L);
}

#line 240 "sclm153.sqx"

   CHECKERR ("CONNECT RESET");

   return -99;
} /* end of main() */



/**********************************************************************
**  Procedure:  getTime()
**
**  Function:   this function will the order time from the TIME table 
**              or will return 999.9 if the from<->to entry is not in 
**              the TIME table
**********************************************************************/
float getTime(char* table, char* from, char *to)
{
   /* declare for cursor */

   
/*
EXEC SQL DECLARE c2 CURSOR FOR statement2;
*/

#line 259 "sclm153.sqx"
  
   
/*
EXEC SQL BEGIN DECLARE SECTION;
*/

#line 260 "sclm153.sqx"

      char stmt[512];
      double tempTime = 0.0;
   
/*
EXEC SQL END DECLARE SECTION;
*/

#line 263 "sclm153.sqx"

  
   strcpy(stmt, "SELECT double(T) FROM ");
   strcat(stmt, table);
   strcat(stmt, " WHERE point1 = ? AND point2 = ?");
   
/*
EXEC SQL PREPARE statement2 from :stmt;
*/

{
#line 268 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 268 "sclm153.sqx"
  sqlastls(0,stmt,0L);
#line 268 "sclm153.sqx"
  sqlacall((unsigned short)27,4,0,0,0L);
#line 268 "sclm153.sqx"
  sqlastop(0L);
}

#line 268 "sclm153.sqx"

   CHECKERR ("PREPARE");
   
/*
EXEC SQL OPEN c2 USING :from, :to;
*/

{
#line 270 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 270 "sclm153.sqx"
  sqlaaloc(2,2,4,0L);
    {
      struct sqla_setd_list sql_setdlist[2];
#line 270 "sclm153.sqx"
      sql_setdlist[0].sqltype = 460; sql_setdlist[0].sqllen = 30;
#line 270 "sclm153.sqx"
      sql_setdlist[0].sqldata = (void*)from;
#line 270 "sclm153.sqx"
      sql_setdlist[0].sqlind = 0L;
#line 270 "sclm153.sqx"
      sql_setdlist[1].sqltype = 460; sql_setdlist[1].sqllen = 30;
#line 270 "sclm153.sqx"
      sql_setdlist[1].sqldata = (void*)to;
#line 270 "sclm153.sqx"
      sql_setdlist[1].sqlind = 0L;
#line 270 "sclm153.sqx"
      sqlasetd(2,0,2,sql_setdlist,0L);
    }
#line 270 "sclm153.sqx"
  sqlacall((unsigned short)26,4,2,0,0L);
#line 270 "sclm153.sqx"
  sqlastop(0L);
}

#line 270 "sclm153.sqx"

   CHECKERR ("OPEN");
   
/*
EXEC SQL FETCH c2 INTO :tempTime;
*/

{
#line 272 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 272 "sclm153.sqx"
  sqlaaloc(3,1,5,0L);
    {
      struct sqla_setd_list sql_setdlist[1];
#line 272 "sclm153.sqx"
      sql_setdlist[0].sqltype = 480; sql_setdlist[0].sqllen = 8;
#line 272 "sclm153.sqx"
      sql_setdlist[0].sqldata = (void*)&tempTime;
#line 272 "sclm153.sqx"
      sql_setdlist[0].sqlind = 0L;
#line 272 "sclm153.sqx"
      sqlasetd(3,0,1,sql_setdlist,0L);
    }
#line 272 "sclm153.sqx"
  sqlacall((unsigned short)25,4,0,3,0L);
#line 272 "sclm153.sqx"
  sqlastop(0L);
}

#line 272 "sclm153.sqx"

   CHECKERR ("FETCH");
   
/*
EXEC SQL CLOSE c2;
*/

{
#line 274 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 274 "sclm153.sqx"
  sqlacall((unsigned short)20,4,0,0,0L);
#line 274 "sclm153.sqx"
  sqlastop(0L);
}

#line 274 "sclm153.sqx"

   CHECKERR ("SELECT INTO FROM TIME TABLE");

   if (tempTime == 0.0) {  /* entry not found ?                      */
     tempTime = 999.9;     /* set bogus time to allow continued      */ 
   }                       /*   processing                           */

   return (tempTime);      /* return the time.                       */
} /* end of getTime() */


/**********************************************************************
** Procedure : check_error
**
** Purpose :   This procedure checks the SQLCACODE flag and prints  
**             out any information that is available related to the 
**             specific error.
**
***********************************************************************/
int check_error (char eString[], struct sqlca *caPointer) {
   char eBuffer[1024];
   char sBuffer[1024];
   short rc, Erc;

   if (caPointer->sqlcode != 0) {
      printf("--- error report ---<br>ERROR occured : %s", eString);
      printf("SQLCODE : %d<br>", caPointer->sqlcode);

      /**********************\
      * GET SQLSTATE MESSAGE *
      \**********************/

      rc = sqlogstt (sBuffer, 1024, 80, caPointer->sqlstate);

      /******************************\
      * GET ERROR MESSAGE API called *
      \******************************/

      Erc = sqlaintp (eBuffer, 1024, 80, caPointer);

      /* return code is the length of the eBuffer string */

      if (Erc > 0) 
         printf("%s", eBuffer);

      if (caPointer->sqlcode < 0) {
         printf("%s--- end error report ---<br>", sBuffer);
         return 1;
      } else {
         /* errorCode is just a Warning message */
         printf("%s--- end error report ---<br>", sBuffer);
         printf("WARNING - CONTINUING PROGRAM WITH ERRORS!<br>");
         return 0;
      } /* endif */
   } /* endif */
   return 0;
} /* end of check_error() */


/**********************************************************************
** autoBind()
**
** This function "probes" the current database to see whether a bind
** is needed.
**
**********************************************************************/
static long autoBind(char *bindFile, /* IN, bind file name           */
                     char *msgFile,  /* IN, message file name, 
                                                         can be null */
                     char *dbName)   /* OUT, VARCHAR(18),
                                                      CURRENT SERVER */
{
   
/*
EXEC SQL BEGIN DECLARE SECTION;
*/

#line 346 "sclm153.sqx"

   char hvBindCurrentServer[19];
   
/*
EXEC SQL END DECLARE SECTION;
*/

#line 348 "sclm153.sqx"


   /* check for "program not bound" or "timestamp conflict" errors */
   
/*
EXEC SQL VALUES(CURRENT SERVER) INTO :hvBindCurrentServer;
*/

{
#line 351 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 351 "sclm153.sqx"
  sqlaaloc(3,1,6,0L);
    {
      struct sqla_setd_list sql_setdlist[1];
#line 351 "sclm153.sqx"
      sql_setdlist[0].sqltype = 460; sql_setdlist[0].sqllen = 19;
#line 351 "sclm153.sqx"
      sql_setdlist[0].sqldata = (void*)hvBindCurrentServer;
#line 351 "sclm153.sqx"
      sql_setdlist[0].sqlind = 0L;
#line 351 "sclm153.sqx"
      sqlasetd(3,0,1,sql_setdlist,0L);
    }
#line 351 "sclm153.sqx"
  sqlacall((unsigned short)24,5,0,3,0L);
#line 351 "sclm153.sqx"
  sqlastop(0L);
}

#line 351 "sclm153.sqx"

   if ((SQLCODE == -805) || (SQLCODE == -818)) {
      struct sqlca sqlcaStruct = {0};
      struct sqlopt sqloptStructPointer = {0};

      if (NULL == bindFile) {
         printf("<H3>ERROR: %s autobind: bindfile is NULL ",
                SQLFunctionName);
         return -1;
      }
      if (NULL == msgFile) {
         printf("<H3>ERROR: %s autobind: msgfile is NULL",
                SQLFunctionName);
         return -1;
      }

      sqlabndx(bindFile, msgFile, &sqloptStructPointer, &sqlcaStruct);
      if (sqlcaStruct.sqlcode < 0) {
         printf("<H3>ERROR: %s Bind Error: msgFile is %s",
                SQLFunctionName,
                msgFile);
         return -1;
      }
      
/*
EXEC SQL VALUES(CURRENT SERVER) INTO :hvBindCurrentServer;
*/

{
#line 374 "sclm153.sqx"
  sqlastrt(sqla_program_id, &sqla_rtinfo, &sqlca);
#line 374 "sclm153.sqx"
  sqlaaloc(3,1,7,0L);
    {
      struct sqla_setd_list sql_setdlist[1];
#line 374 "sclm153.sqx"
      sql_setdlist[0].sqltype = 460; sql_setdlist[0].sqllen = 19;
#line 374 "sclm153.sqx"
      sql_setdlist[0].sqldata = (void*)hvBindCurrentServer;
#line 374 "sclm153.sqx"
      sql_setdlist[0].sqlind = 0L;
#line 374 "sclm153.sqx"
      sqlasetd(3,0,1,sql_setdlist,0L);
    }
#line 374 "sclm153.sqx"
  sqlacall((unsigned short)24,6,0,3,0L);
#line 374 "sclm153.sqx"
  sqlastop(0L);
}

#line 374 "sclm153.sqx"

   }
   CHECKERR("BIND TO DATABASE");

   return 0;

} /* end of autoBind() */

      /*************\
      * END OF FILE *
      \*************/                   
