/*****************************************************************************
*  File Name: scoption.cmd                                                   *
*                                                                            *
*  Description:  This program creates part of the WEB page based on the      *
*                 user's role                                                *
*                                                                            *
*  Inputs:   table1, macroPath, uName, bkground                              *
*                                                                            *
*  Outputs:  N/A                                                             *
*                                                                            *
*  Returns:  N/A                                                             *
*                                                                            *
*                    ------------------------------------                    *
*                                                                            *
*   Licensed Materials - Property of IBM                                     *
*                                                                            *
*   (C) COPYRIGHT International Business Machines Corp. 1996                 *
*    All Rights Reserved.                                                    *
*                                                                            *
*   US Government Users Restricted Rights - Use, duplication or              *
*   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.        *
*                                                                            *
*                    ------------------------------------                    *
*                                                                            *
*               NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                  *
*                                                                            *
*  INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE      *
*  EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS" WITHOUT    *
*  WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT     *
*  LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A    *
*  PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE    *
*  OF THE SOURCE CODE EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, *
*  IS WITH YOU.  SHOULD ANY PART OF THE SOURCE CODE EXAMPLES PROVE           *
*  DEFECTIVE, YOU (AND NOT IBM) ASSUME THE ENTIRE COST IF ALL NECESSARY      *
*  SERVICING, REPAIR OR CORRECTION.                                          *
*                                                                            *
******************************************************************************/

/** Initialize parms **/
j=2
uName=addESCseq(uName)

/** Determine the role **/
If datatype(table1_rows,'w') & Datatype(table1_cols,'w') Then
 Do i=1 to table1_rows
  Select 
   When table1_V.i.j = 'Customer'     Then  Call Role_cust
   When table1_V.i.j = 'Dealer'       Then  Call Role_dealer
   When table1_V.i.j = 'Truck Driver' Then  Call Role_truckDriver
   Otherwise Say '<p> Error: findrole found an unknown role ('table1_V.i.j')',
                     'in the data-base!'
  End
 End

Exit

/*======================================================================*/
addESCseq:
  Procedure
  Parse Arg a
  nURLchar='0920222325262F3A3B3C3D3E3F405B5C5D5E607B7C7D7E'x
  n=Verify(a,nURLchar,"M")                    /** find first instance        **/
  Do While n>0
   newChar = '&#'||C2d(Substr(a,n,1))';'      /** get URL encoded char       **/
   a=Delstr(Insert(newChar,a,n),n,1)          /** replace disallowed char    **/
   n=Verify(a,nURLchar,"M",n+Length(newChar)) /** move beyond inserted char  **/
  End                                         /**  and find the next instance**/
Return a

/*======================================================================*/
Role_cust:
 Say '<hr>'
 Say '<form method="post" action="'macroPath'scshowrm.mac/report">'
 say '<input type="hidden" name=usrname value="'uName'">'
 Say '<input type="hidden" name=rBackground value="'bkground'">'
 say '<input TYPE=SUBMIT value="Order your sports car from the showroom">'
 say '</form>'
 say '<form method="post" action="'macroPath'scqcstat.mac/input">'
 say '<input type="hidden" name=usrname value="'uName'">'
 Say '<input type="hidden" name=rBackground value="'bkground'">'
 Say '<input type="hidden" name=return value="'macroPath'scgetusr.mac/report">'
 say '<input TYPE=SUBMIT value="Check status of your ordered car">'
 say '</form>'
Return

/*======================================================================*/
Role_dealer:
 Say '<hr>'
 say '<form method="post" action="'macroPath'scqdstat.mac/input">'
 say '<input type="hidden" name=usrname value="'uName'">'
 Say '<input type="hidden" name=rBackground value="'bkground'">'
 Say '<input type="hidden" name=return value="'macroPath'scgetusr.mac/report">'
 say '<input TYPE=SUBMIT value="Check status of all ordered cars">'
 say '</form>'
 Say '<form method="post" action="'macroPath'sclm.mac/input">'
 Say '<input type="hidden" name=usrname value="'uName'">'
 Say '<input type="hidden" name=rBackground value="'bkground'">'
 Say '<input type="hidden" name=return value="'macroPath'scgetusr.mac/report">'
 Say '<input TYPE=SUBMIT value="Run delivery router ">'
 Say '</form>'
 Say '<form method="post" action="'macroPath'scshowrm.mac/report">'
 say '<input type="hidden" name=usrname value="'uName'">'
 Say '<input type="hidden" name=rBackground value="'bkground'">'
 say '<input TYPE=SUBMIT value="Order your sports car from the showroom">'
 say '</form>'
 say '<form method="post" action="'macroPath'scqcstat.mac/input">'
 say '<input type="hidden" name=usrname value="'uName'">'
 Say '<input type="hidden" name=rBackground value="'bkground'">'
 Say '<input type="hidden" name=return value="'macroPath'scgetusr.mac/report">'
 say '<input TYPE=SUBMIT value="Check status of your ordered car">'
 say '</form>'
Return

/*======================================================================*/
Role_truckDriver:
 Say '<hr>'
 Say '<form method="post" action="'macroPath'sclm.mac/input">'
 Say '<input type="hidden" name=usrname value="'uName'">'
 Say '<input type="hidden" name=rBackground value="'bkground'">'
 Say '<input type="hidden" name=return value="'macroPath'scgetusr.mac/report">'
 Say '<input TYPE=SUBMIT value="Run delivery router ">'
 Say '</form>'
 Say '<form method="post" action="'macroPath'scdelver.mac/input">'
 Say '<input type="hidden" name=usrname value="'uName'">'
 Say '<input type="hidden" name=rBackground value="'bkground'">'
 Say '<input type="hidden" name=return value="'macroPath'scgetusr.mac/report">'
 Say '<input TYPE=SUBMIT value="Check your proposed delivery route">'
 Say '</form>'
 Say '<form method="post" action="'macroPath'scdelver.mac/qryroute">'
 Say '<input type="hidden" name=usrname value="'uName'">'
 Say '<input type="hidden" name=rBackground value="'bkground'">'
 Say '<input type="hidden" name=return value="'macroPath'scgetusr.mac/report">'
 Say '<input TYPE=SUBMIT value="Check your committed delivery route">'
 Say '</form>'
 Say '<form method="post" action="'macroPath'scdelver.mac/history">'
 Say '<input type="hidden" name=usrname value="'uName'">'
 Say '<input type="hidden" name=rBackground value="'bkground'">'
 Say '<input type="hidden" name=return value="'macroPath'scgetusr.mac/report">'
 Say '<input TYPE=SUBMIT value="View or Erase your old delivery route">'
 Say '</form>'
 Say '<form method="post" action="'macroPath'scshowrm.mac/report">'
 say '<input type="hidden" name=usrname value="'uName'">'
 Say '<input type="hidden" name=rBackground value="'bkground'">'
 say '<input TYPE=SUBMIT value="Order your sports car from the showroom">'
 say '</form>'
 say '<form method="post" action="'macroPath'scqcstat.mac/input">'
 say '<input type="hidden" name=usrname value="'uName'">'
 Say '<input type="hidden" name=rBackground value="'bkground'">'
 Say '<input type="hidden" name=return value="'macroPath'scgetusr.mac/report">'
 say '<input TYPE=SUBMIT value="Check status of your ordered car">'
 say '</form>'
Return
